设为首页收藏本站

晓东CAD家园-论坛

 找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 73|回复: 3

[你问我答] (XDGE几何库应用)将圆转换成多段线圆

[复制链接]

签到天数: 1028 天

连续签到: 18 天

[LV.10]以坛为家III

已领礼包: 40个

财富等级: 招财进宝

发表于 2017-7-28 10:42:04 | 显示全部楼层 |阅读模式

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有帐号?立即注册

x
本帖最后由 newer 于 2017-7-28 10:54 编辑

问: 如何将圆实体转换多段线圆

答:使用XDRX API的 AcGe几何库,可以很方便的做到,

  1. (defun c:cir->pline ()
  2.   (if (setq e (car (xdrx_entsel "\n选取圆实体<退出>:" '((0 . "CIRCLE")))))
  3.     (progn
  4.       (setq g-cir (xdge::constructor e)) ;;构建圆的几何实体
  5.       (setq g-pline (xdge::constructor "kCompositeCrv3d" g-cir));;构建多段线几何实体
  6.       (if (xdrx_entity_handoverTo e g-pline) ;;将数据库圆实体和内存的几何实体交换,交换后数据库实体变成内存实体的类型,属性保留。
  7.         (progn
  8.           (xdrx_prompt "\n成功转换到多段线圆.")
  9.           (xdrx_setpropertyvalue e "constantwidth" 0.5) ;;多段线加粗
  10.         )
  11.       )
  12.       (xdge::free g-cir g-pline) ;;释放几何实体内存
  13.     )
  14.   )
  15.   (princ)
  16. )



上面构建几何PLINE实体的代码,也可以写成下面

  1.       (setq g-pline (xdge::constructor "kCompositeCrv3d"));;构建多段线几何“空”实体

  2.       (setq g-pline (xdge::setpropertyvalue g-pline "setcurvelist" g-cir));;添加圆(AcGeCircArc3d)几何实体到g-pline中。



QQ截图20170728103637.png

论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!

签到天数: 1283 天

连续签到: 5 天

[LV.10]以坛为家III

已领礼包: 604个

财富等级: 财运亨通

发表于 2017-7-28 11:29:59 | 显示全部楼层
还是要转成两个半圆吗?
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

签到天数: 1028 天

连续签到: 18 天

[LV.10]以坛为家III

已领礼包: 40个

财富等级: 招财进宝

 楼主| 发表于 2017-7-28 11:47:14 | 显示全部楼层

两段弧线组成的PLINE线。
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

签到天数: 1028 天

连续签到: 18 天

[LV.10]以坛为家III

已领礼包: 40个

财富等级: 招财进宝

 楼主| 发表于 2017-7-28 11:49:12 | 显示全部楼层

ARX 几何库 AcGeCompositeCrv3d 对象的构造函数接受AcGeCircArc3d对象做参数构造多段线的几何实体模型。
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|小黑屋|手机版|Archiver|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )  

GMT+8, 2018-6-22 01:36 , Processed in 0.141810 second(s), 29 queries , Gzip On, WinCache On.

Powered by Discuz! X3.4

© 2001-2017 Comsenz Inc.

快速回复 返回顶部 返回列表